org.apache.hc.core5.http.nio.support

## Class BasicClientExchangeHandler<T>

- java.lang.Object
- - org.apache.hc.core5.http.nio.support.BasicClientExchangeHandler<T>

- Type Parameters:
    `T` - The result type.
  All Implemented Interfaces:
    AsyncClientExchangeHandler, AsyncDataConsumer, AsyncDataExchangeHandler, AsyncDataProducer, ResourceHolder

      public final class BasicClientExchangeHandler<T>
      extends Object
      implements AsyncClientExchangeHandler

  Basic `AsyncClientExchangeHandler` implementation that makes use of `AsyncRequestProducer` to generate request message and `AsyncResponseConsumer` to process the response message returned by the server.
  Since:
    5.0

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `BasicClientExchangeHandler(AsyncRequestProducer requestProducer, AsyncResponseConsumer<T> responseConsumer, FutureCallback<T> resultCallback)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `available()` Returns the number of bytes immediately available for output.
    `void` | `cancel()` Triggered to cancel the message exchange.
    `void` | `consume(ByteBuffer src)` Triggered to pass incoming data to the data consumer.
    `void` | `consumeInformation(HttpResponse response, HttpContext httpContext)` Triggered to signal receipt of an intermediate (1xx) HTTP response.
    `void` | `consumeResponse(HttpResponse response, EntityDetails entityDetails, HttpContext httpContext)` Triggered to signal receipt of a response message head.
    `void` | `failed(Exception cause)` Triggered to signal a failure in data processing.
    `void` | `produce(DataStreamChannel channel)` Triggered to signal the ability of the underlying data channel to accept more data.
    `void` | `produceRequest(RequestChannel requestChannel, HttpContext httpContext)` Triggered to signal the ability of the underlying request channel to accept a request messages.
    `void` | `releaseResources()`
    `void` | `streamEnd(List<? extends Header> trailers)` Triggered to signal termination of the data stream.
    `void` | `updateCapacity(CapacityChannel capacityChannel)` Triggered to signal ability of the underlying data stream to receive data capacity update.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### BasicClientExchangeHandler

          public BasicClientExchangeHandler(AsyncRequestProducer requestProducer,
                                            AsyncResponseConsumer<T> responseConsumer,
                                            FutureCallback<T> resultCallback)

  - ### Method Detail

    - #### produceRequest

          public void produceRequest(RequestChannel requestChannel,
                                     HttpContext httpContext)
                              throws HttpException,
                                     IOException

      Description copied from interface: `AsyncClientExchangeHandler`
      Triggered to signal the ability of the underlying request channel to accept a request messages. The data producer can choose to send a request message immediately inside the call or asynchronously at some later point.
      Specified by:
        `produceRequest` in interface `AsyncClientExchangeHandler`
      Parameters:
        `requestChannel` - the request channel capable to accepting a request message.
        `httpContext` - the actual execution context.
      Throws:
        `HttpException` - in case of an HTTP protocol violation.
        `IOException` - in case of an I/O error.

    - #### available

          public int available()

      Description copied from interface: `AsyncDataProducer`
      Returns the number of bytes immediately available for output. This method can be used as a hint to control output events of the underlying I/O session.

      Please note this method should return zero if the data producer is unable to produce any more data, in which case `AsyncDataProducer.produce(DataStreamChannel)` method will not get triggered. The producer can resume writing out data asynchronously once more data becomes available or request output readiness events with `DataStreamChannel.requestOutput()`.

      Specified by:
        `available` in interface `AsyncDataProducer`
      Returns:
        the number of bytes immediately available for output
      See Also:
        `AsyncDataProducer.produce(DataStreamChannel)`, `DataStreamChannel.requestOutput()`

    - #### produce

          public void produce(DataStreamChannel channel)
                       throws IOException

      Description copied from interface: `AsyncDataProducer`
      Triggered to signal the ability of the underlying data channel to accept more data. The data producer can choose to write data immediately inside the call or asynchronously at some later point.

      Please note this method gets triggered only if `AsyncDataProducer.available()` returns a positive value.

      Specified by:
        `produce` in interface `AsyncDataProducer`
      Parameters:
        `channel` - the data channel capable of accepting more data.
      Throws:
        `IOException` - in case of an I/O error.
      See Also:
        `AsyncDataProducer.available()`

    - #### consumeInformation

          public void consumeInformation(HttpResponse response,
                                         HttpContext httpContext)
                                  throws HttpException,
                                         IOException

      Description copied from interface: `AsyncClientExchangeHandler`
      Triggered to signal receipt of an intermediate (1xx) HTTP response.
      Specified by:
        `consumeInformation` in interface `AsyncClientExchangeHandler`
      Parameters:
        `response` - the intermediate (1xx) HTTP response.
        `httpContext` - the actual execution context.
      Throws:
        `HttpException` - in case of an HTTP protocol violation.
        `IOException` - in case of an I/O error.

    - #### consumeResponse

          public void consumeResponse(HttpResponse response,
                                      EntityDetails entityDetails,
                                      HttpContext httpContext)
                               throws HttpException,
                                      IOException

      Description copied from interface: `AsyncClientExchangeHandler`
      Triggered to signal receipt of a response message head.
      Specified by:
        `consumeResponse` in interface `AsyncClientExchangeHandler`
      Parameters:
        `response` - the response message head.
        `entityDetails` - the response entity details or `null` if the response does not enclose an entity.
        `httpContext` - the actual execution context.
      Throws:
        `HttpException` - in case of an HTTP protocol violation.
        `IOException` - in case of an I/O error.

    - #### cancel

          public void cancel()

      Description copied from interface: `AsyncClientExchangeHandler`
      Triggered to cancel the message exchange.
      Specified by:
        `cancel` in interface `AsyncClientExchangeHandler`

    - #### updateCapacity

          public void updateCapacity(CapacityChannel capacityChannel)
                              throws IOException

      Description copied from interface: `AsyncDataConsumer`
      Triggered to signal ability of the underlying data stream to receive data capacity update. The data consumer can choose to write data immediately inside the call or asynchronously at some later point.
      Specified by:
        `updateCapacity` in interface `AsyncDataConsumer`
      Parameters:
        `capacityChannel` - the channel for capacity updates.
      Throws:
        `IOException` - in case of an I/O error.

    - #### consume

          public void consume(ByteBuffer src)
                       throws IOException

      Description copied from interface: `AsyncDataConsumer`
      Triggered to pass incoming data to the data consumer. The consumer must consume the entire content of the data buffer. The consumer must stop incrementing its capacity on the capacity channel if it is unable to accept more data. Once the data consumer has handled accumulated data or allocated more intermediate storage it can update its capacity information on the capacity channel.
      Specified by:
        `consume` in interface `AsyncDataConsumer`
      Parameters:
        `src` - data source.
      Throws:
        `IOException` - in case of an I/O error.

    - #### streamEnd

          public void streamEnd(List<? extends Header> trailers)
                         throws HttpException,
                                IOException

      Description copied from interface: `AsyncDataConsumer`
      Triggered to signal termination of the data stream.
      Specified by:
        `streamEnd` in interface `AsyncDataConsumer`
      Parameters:
        `trailers` - data stream trailers.
      Throws:
        `HttpException` - in case of an HTTP protocol violation.
        `IOException` - in case of an I/O error.

    - #### failed

          public void failed(Exception cause)

      Description copied from interface: `AsyncDataExchangeHandler`
      Triggered to signal a failure in data processing.
      Specified by:
        `failed` in interface `AsyncDataExchangeHandler`
      Parameters:
        `cause` - the cause of the failure.

    - #### releaseResources

          public void releaseResources()

      Specified by:
        `releaseResources` in interface `ResourceHolder`

Copyright © 2005–2021 The Apache Software Foundation. All rights reserved.